; $Id$




function ooDisplayEcho::handleTreeContextMultipleSelectREMOVEMULTIPLEOBJ,selected,refids
  print,'ooDisplayEcho::handleTreeContextMultipleSelectREMOVEMULTIPLEOBJ'
  ;print,uval.id ;SORT AND THEN REMOVE HIGHEST POSITION FIRST.  NO NEED TO STORE REFID'S SINCE THESE ITEMS REMOVED.
  print,selected,refids
  ssort = reverse(sort(selected))
  sselected = selected[ssort]
      for i=0,n_elements(sselected)-1 do begin

          ;LRK - 12/09/08
          ;NOW INSTEAD OF SETTING THE TYPE I CALL THE FITALL ROUTINE. 

          ;ref = self.datacontainer->get(position=selected[i])
          ref = self.datacontainer->get(position=sselected[i])
          self.datacontainer->remove,position=sselected[i]
          obj_destroy,ref

          ;print,i,selected[i],'ooDisplayEcho::handleMultipleTreeSelect  --- USED KEYWORDS OR EVENT OPTION TO CHOOSE HANDLING OPTION'
          ;help,event,/structure
          ;ref->storeFitparms
          ;ref_tavestate = ref->report_timeaverage_state()
          ;ref->arcFit,tavestate=ref_tavestate
  
          
          
          help,ref,output=refid,struct=0
          refseg = (strsplit(refid,'=',/extract))[1]
          refids[i] = refseg
      endfor;i



  return,1
end;function ooDisplayEcho::handleTreeContextMultipleSelectREMOVEMULTIPLEOBJ




pro ooDisplayEcho::MultiselectPhaseImportDialogEvents,event
;
;NAME:
;        ooDisplayEcho::MultiselectPhaseImportDialogEvents
;
;PURPOSE:
;           Handle various "list" events.  These events may come from
;           phase import, IQT, and set selection dialogs.
;PARAMETERS:
;
;KEYWORDS:
;


;    print,'ListEvent'

    widget_control,event.id,get_uvalue=obj

    case obj.id of
        'OKBUTTON':begin

;print,'OKBUTTON????'
                        widget_control,self.phaseImportList,get_uvalue=pil
                        objIndexList = pil.list

                        index=widget_info(self.phaseImportList,$
                                            /droplist_select)


                        m=self.QChoiceIndex
                        n=objIndexList[index]

                        ;NEED TO DETERMINE HERE IF THE DIMENSIONS
                        ;OF THE CARBOPACK AND SAMPLE ARE THE
                        ;SAME.  IF SO, IMPORT PHASES DIRECTLY.
                        ;IF NOT, INTERPOLATE.
                        ;
                        ;HOLD ON. . .
                        ;WHY NOT JUST ALWAYS INTERPOLATE EXCEPT WHEN
                        ;DETECTOR BINNING IS NOT IDENTICAL????
                        ;
                        objTo = ((self.dataContainer)->get(position=m))
                        objFrom = ((self.dataContainer)->get(position=n))

                        self.fixed = self->getFixed()

                        savefixed = self.fixed


                        ;GET THE FIX/VARY PHASE VALUE FROM THE WIDGET
                        fixvaryphasedl = widget_info(self.phaseImportBase,$
                                        find_by_uname='PHASEIMPORTFIXVARYPHASE')

                        if widget_info(fixvaryphasedl,/droplist_select) eq 2 then begin
                            ;FIT PHASE OFFSET
                            self.fixed[2] = 1
                            fitphaseoffset = 1
                        endif else begin
                            self.fixed[2] = widget_info(fixvaryphasedl,/droplist_select)
                            fitphaseoffset = 0
                        endelse


                        ;GET THE FIX/VARY PERIOD VALUE FROM THE WIDGET
                        fixvaryperioddl = widget_info(self.phaseImportBase,$
                                        find_by_uname='PHASEIMPORTFIXVARYPERIOD')

                        self.fixed[4] = widget_info(fixvaryperioddl,/droplist_select)

                        allownegamp = widget_info(self.phaseImportBase,$
                                        find_by_uname='ALLOWNEGATIVEAMPLITUDECHECKBOX')
                        widget_control,allownegamp,get_value=negamp

                        forcenegamp = widget_info(self.phaseImportBase,$
                                        find_by_uname='FORCENEGATIVEAMPLITUDECHECKBOX')
                        widget_control,forcenegamp,get_value=forcenegamp

                        widget_control,self.phaseImportBase,/destroy

                        widget_control,self.atwphase,get_value=sphaseoffset
                        phaseoffset = double(sphaseoffset)  ;ALWAYS 0.0 SINCE THIS TEXT BOX IS NOT SHOWN.
                        widget_control,self.atwomega,get_value=somega

;120904
;CONVERT PERIOD TO OMEGA.
;print,omega
                        omega = 1.0/double(somega)

;print,omega
                        ;1) GET fixed VALUES FROM GUI AND PASS TO
                        ;   DATA OBJECT HERE.
                        ;
                        ;2) PASS VALUE IN PHASE OFFSET BOX IF NON-ZERO.


;LRK - 11/12/09
;UPDATE THE NEXT SECTION TO GET THE INFORMATION AND RETURN IT SO 
;THAT THE CALLING ROUTINE CAN COLLECT IT AND PROCESS ALL THE DATA OBJECTS
;IN ONE LOOP.  
;
;---------------------------------------------------------------------------------
;                        (self.dataContainer->get(position=$
;                                m))->fitAllFixedPhase,$
;                                objFrom,$
;                                fixed=self.fixed,$
;                                startparms=startparms,$
;                                obj=self,$
;                                phaseoffset = phaseoffset,$
;                                fitphaseoffset=fitphaseoffset,$
;                                omega=omega,$
;                                allownegamp=negamp,$
;                                forcenegamp=forcenegamp
;
;                        self.fixed = savefixed  ;THIS IS IRRELEVANT NOW THAT
;                                                ;"fixed"
;                        self->redefineTree
;                        self->redefineWidgets,self.QChoiceIndex
;                        self->draw
;---------------------------------------------------------------------------------


                    end
        'CANCELBUTTON':begin
                        widget_control,self.phaseImportBase,/destroy
                    end
        else:begin
            end
    endcase


end;MultiselectPhaseImportDialogEvents
pro MultiselectPhaseImportBaseCleanup,base
;
;NAME:
;        MultiselectPhaseImportBaseCleanup
;
;PURPOSE:
;
;PARAMETERS:
;
;KEYWORDS:
;
;_EXTRA - is used to pass keywords meant for the superclass.

    ;CALLED WHEN [X] EVENT OCCURS.
    print,'pib Cleanup'
    widget_control,base,get_uvalue=pib
;    print,base,self.atlb
    call_method,pib.method,pib.object,pib.event

end;MultiselectPhaseImportBaseCleanup

pro ooDisplayEcho::MultiselectDefinePhaseImportDialog
;
;NAME:
;        ooDisplayEcho::MultiselectDefinePhaseImportDialog
;
;PURPOSE:
;           Create a dialog to select the data object to import phases from
;           for fitting.
;PARAMETERS:
;           none
;KEYWORDS:
;           none


    ;;
    ;
    ;NEED AN EVENT HANDLER TO SET THE SELECTED PHASES
    ;
    ;;;

    refo = self.dataContainer->get(position=self.QChoiceIndex)
    theList = ['']
    objIndexList = [0]
    for i = 0,self.dataContainer->count()-1 do begin
        refi = self.dataContainer->get(position=i)
        if (refo)->matches(refi) $
                    and (i ne self.QChoiceIndex) $
                        and (refi->getproperty(tag='type') ne 3) $ ;ONLY SELECT FROM NON-CELL DATA
                            then begin
;                            print,$
;                            (self.dataContainer->get(position=$
;                                i))->getProperty(tag='filename')

                            ;ADD SUCCESSFUL ITEMS TO THE LIST, BUT ADD RESOLUTION FILES TO BEGINNING.
                            if (refi->getproperty(tag='type') eq 1) and $
                                (n_elements(theList) gt 1) then begin
                                theList[0] =file_basename(refi->getProperty(tag='filename'))
                                objIndexList[0] = i
                                theList = $
                                    ['',theList]
                                objIndexList = [0,objIndexList]
                            endif else begin
                                theList = $
                                    [theList,file_basename(refi->getProperty(tag='filename'))]
                                objIndexList = [objIndexList,i]
                            endelse

        endif
    endfor
    if n_elements(theList) gt 1 then begin
        theList = theList[1:*]
        objIndexList = objIndexList[1:*]

        self.phaseImportBase = widget_base(group_leader = self.atlb,$
                                            $;xsize=156,ysize=140,$
                                            /modal,/col,$;/grid_layout,$
                                            title='SELECT PHASE SET')

        subBase = widget_base(self.phaseImportBase,/column)
        self.phaseImportList = widget_droplist(subBase,$
                                            value=theList,$
                                            ysize=25,xsize = 250,$
                                            uvalue = {object:self,$
                                                      method:'MultiselectPhaseImportDialogEvents',$
                                                      id:'PHASEIMPORTLIST',$
                                                      list:objIndexList})

        fixvaryphaselist = widget_droplist(subBase,$
                                            title='phase',$
                                            value=['vary','fix','fit phase offset (constant phase)'],$
                                            ysize=25,xsize = 250,$
                                            uname = 'PHASEIMPORTFIXVARYPHASE',$
                                            uvalue = {object:self,$
                                                      method:'doNothing',$
                                                      id:'PHASEIMPORTFIXVARYPHASE',$
                                                      list:objIndexList})

;111405
;SET FIX/VARY BASED ON OBJ TYPE:
;0
;
refotype = refo->getproperty(tag='type')
;print,'refotype=',refotype
        widget_control,fixvaryphaselist, SET_DROPLIST_SELECT=0

        fixvaryperiodlist = widget_droplist(subBase,$
                                            title='period',$
                                            value=['vary','fix'],$
                                            ysize=25,xsize = 250,$
                                            uname = 'PHASEIMPORTFIXVARYPERIOD',$
                                            uvalue = {object:self,$
                                                      method:'doNothing',$
                                                      id:'PHASEIMPORTFIXVARYPERIOD',$
                                                      list:objIndexList})
        widget_control,fixvaryperiodlist, SET_DROPLIST_SELECT=1



        allowNegAmpCheckbox = cw_bgroup(subBase,$
                                        'Allow Small Opposite-Sign Amplitudes',$
                                        /nonexclusive,$
                                        /no_release,$
                                        uname = 'ALLOWNEGATIVEAMPLITUDECHECKBOX',$
                                        uvalue = {object:self,$
                                                  method:'doNothing',$
                                                  id:'ALLOWNEGATIVEAMPLITUDECHECKBOX',$
                                                  list:objIndexList})
        forceNegAmpCheckbox = cw_bgroup(subBase,$
                                        'Force Negative Amplitudes',$
                                        /nonexclusive,$
                                        /no_release,$
                                        uname = 'FORCENEGATIVEAMPLITUDECHECKBOX',$
                                        uvalue = {object:self,$
                                                  method:'doNothing',$
                                                  id:'FORCENEGATIVEAMPLITUDECHECKBOX',$
                                                  list:objIndexList})
        widget_control,allownegampcheckbox,set_value=1

        okButton = widget_button(subBase,value = 'OK',$
                                         xsize=150,ysize=50,$
                                         uvalue = {object:self,$
                                                   method:'MultiselectPhaseImportDialogEvents',$
                                                   id:'OKBUTTON',$
                                                   list:objIndexList})
        cancelButton = widget_button(subBase,value = 'Cancel',$
                                             xsize=150,ysize=50,$
                                             uvalue = {object:self,$
                                                       method:'MultiselectPhaseImportDialogEvents',$
                                                       id:'CANCELBUTTON',$
                                                       list:objIndexList})


        widget_control,self.phaseImportBase,/realize


        ;CREATE DUMMY EVENT STRUCTURE FOR EVENT HANDLING
        dumEvent = { WIDGET_DROPLIST,$
                         ID:self.phaseImportBase,$
                         TOP:self.phaseImportBase,$
                         HANDLER:0L, INDEX:0L }

        ;STICK EVENT AND OTHER INFORMATION INTO BASE UVALUE
        widget_control,self.phaseImportBase,set_uvalue=$
                                            {object:self,$
                                             method:'MultiselectPhaseImportDialogEvents',$
                                             id:'CANCELBUTTON',$
                                             list:objIndexList,$
                                             event:dumEvent}

        xmanager,"ooDisplayEcho",self.phaseImportBase,/no_block,$
                    cleanup='MultiselectPhaseImportBaseCleanup'

    endif else begin
        void = widget_message('No Suitable Data Objects.')
    endelse

end;MultiselectDefinePhaseImportDialog

pro MultiselectPhaseImportDialog_getOneInfo_event,event
  widget_control,event.handler,get_uvalue=pstate
  
  case event.id of
  (*pstate).tlb:
  (*pstate).ok:widget_control,(*pstate).tlb,/destroy
  (*pstate).cancel:widget_control,(*pstate).tlb,/destroy
  else:
  endcase
   
end;MultiselectPhaseImportDialog_getOneInfo_event
function MultiselectPhaseImportDialog_getOneInfo,thisfile,dialog_parent,thelist,objindexlist
          tlb = widget_base(title='Phase input for '+thisFile,group_leader=dialog_parent)
          ok = widget_button(tlb,value='OK',xsize=300)
          cancel = widget_button(tlb,value='Cancel',xsize=300)
          centertlb,tlb
          widget_control,tlb,/realize

;NOW SET UP THE DROPLISTS AND CHECKBOXES AND THIS IS READY TO GO!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


          state = {tlb:tlb,ok:ok,cancel:cancel}
          pstate = ptr_new(state)
          widget_control,tlb,set_uvalue=pstate
          buttonId = 0L
          x = 0
          xmanager,'MultiselectPhaseImportDialog_getOneInfo',tlb
          state = *pstate  ;EXTRACT DATA FROM POINTER
          ptr_free,pstate  ;CLEAN UP POINTER
          return,state
end;MultiselectPhaseImportDialog_getOneInfo

function MultiselectDefinePhaseImportDialog,n,datacontainer,dialog_parent

    print,'selection indices=',n
    dc = datacontainer
    nobj = n_elements(n)

    ;STORE INDICES FOR EVERYTHING IN ARRAYS AND PASS TO CALLING FUNCTION AS A STRUCTURE
    resChoices = intarr(nobj)
    phasefixvary  = intarr(nobj)
    periodfixvary = intarr(nobj)
    allowsmallnegamp = intarr(nobj)
    forcenegamp = intarr(nobj)
    thisfile = strarr(nobj) ;CURRENT FILE TO FIT
    resfile = strarr(nobj)  ;RES FILE NAME SELECTED FOR PHASE INPUTS (SHOULD CORRESPOND EXACTLY TO resChoices INDICES)
                            ;NEEDED FOR TABLE DISPLAY
                            

  ;GET THE INFO FOR EACH ONE
    for j = 0,n_elements(n)-1  do begin 
          refo = dc->get(position=n[j])
          thisFile[j] = file_basename(refo->getProperty(tag='filename'))
                    
          theList = ['']
          objIndexList = [0]
          for i = 0,dc->count()-1 do begin
              refi = dc->get(position=i)
              if (refo)->matches(refi) $
                          and (i ne n[j]) $
                              and (refi->getproperty(tag='type') ne 3) $ ;ONLY SELECT FROM NON-CELL DATA
                                  then begin

                                  ;ADD SUCCESSFUL ITEMS TO THE LIST, BUT ADD RESOLUTION FILES TO BEGINNING.
                                  if (refi->getproperty(tag='type') eq 1) and $
                                      (n_elements(theList) gt 1) then begin
                                      theList[0] =file_basename(refi->getProperty(tag='filename'))
                                      objIndexList[0] = i
                                      theList = $
                                          ['',theList]
                                      objIndexList = [0,objIndexList]
                                  endif else begin
                                      theList = $
                                          [theList,file_basename(refi->getProperty(tag='filename'))]
                                      objIndexList = [objIndexList,i]
                                  endelse
      
              endif
          endfor
          if n_elements(theList) gt 1 then begin
              theList = theList[1:*]
              objIndexList = objIndexList[1:*]
              print,'theList=',thelist
              print,'objIndexList=',objIndexList
          endif

          ;NOW INFORMATION IS AVAILABLE TO PRODUCE INPUT DIALOG:
          duh = MultiselectPhaseImportDialog_getOneInfo(thisfile[j],dialog_parent,thelist,objindexlist)
          help,duh
  endfor;j
  
  
  
  ;PRESENT A TABLE
  
  ;WAIT FOR GO/REDO SIGNAL

  ;RETURN THE NECESSARY INFO
  info = {resChoices:resChoices,phasefixvary:phasefixvary,periodfixvary:periodfixvary,$
          allowsmallnegamp:allowsmallnegamp,forcenegamp:forcenegamp}
  
  return,info
end;MultiselectDefinePhaseImportDialog

;
;pro ooDisplayEcho::definePhaseImportDialog2
;;
;;NAME:
;;        ooDisplayEcho::definePhaseImportDialog
;;
;;PURPOSE:
;;           Create a dialog to select the data object to import phases from
;;           for fitting.
;;PARAMETERS:
;;           none
;;KEYWORDS:
;;           none
;
;
;    ;;
;    ;
;    ;NEED AN EVENT HANDLER TO SET THE SELECTED PHASES
;    ;
;    ;;;
;
;    refo = self.dataContainer->get(position=self.QChoiceIndex)
;    theList = ['']
;    objIndexList = [0]
;    for i = 0,self.dataContainer->count()-1 do begin
;        refi = self.dataContainer->get(position=i)
;        if (refo)->matches(refi) $
;                    and (i ne self.QChoiceIndex) $
;                        and (refi->getproperty(tag='type') ne 3) $ ;ONLY SELECT FROM NON-CELL DATA
;                            then begin
;;                            print,$
;;                            (self.dataContainer->get(position=$
;;                                i))->getProperty(tag='filename')
;
;                            ;ADD SUCCESSFUL ITEMS TO THE LIST, BUT ADD RESOLUTION FILES TO BEGINNING.
;                            if (refi->getproperty(tag='type') eq 1) and $
;                                (n_elements(theList) gt 1) then begin
;                                theList[0] =file_basename(refi->getProperty(tag='filename'))
;                                objIndexList[0] = i
;                                theList = $
;                                    ['',theList]
;                                objIndexList = [0,objIndexList]
;                            endif else begin
;                                theList = $
;                                    [theList,file_basename(refi->getProperty(tag='filename'))]
;                                objIndexList = [objIndexList,i]
;                            endelse
;
;        endif
;    endfor
;    if n_elements(theList) gt 1 then begin
;        theList = theList[1:*]
;        objIndexList = objIndexList[1:*]
;
;        self.phaseImportBase = widget_base(group_leader = self.atlb,$
;                                            $;xsize=156,ysize=140,$
;                                            /modal,/col,$;/grid_layout,$
;                                            title='SELECT PHASE SET')
;
;        subBase = widget_base(self.phaseImportBase,/column)
;        self.phaseImportList = widget_droplist(subBase,$
;                                            value=theList,$
;                                            ysize=25,xsize = 250,$
;                                            uvalue = {object:self,$
;                                                      method:'listEvents',$
;                                                      id:'PHASEIMPORTLIST',$
;                                                      list:objIndexList})
;
;        fixvaryphaselist = widget_droplist(subBase,$
;                                            title='phase',$
;                                            value=['vary','fix','fit phase offset (constant phase)'],$
;                                            ysize=25,xsize = 250,$
;                                            uname = 'PHASEIMPORTFIXVARYPHASE',$
;                                            uvalue = {object:self,$
;                                                      method:'doNothing',$
;                                                      id:'PHASEIMPORTFIXVARYPHASE',$
;                                                      list:objIndexList})
;
;;111405
;;SET FIX/VARY BASED ON OBJ TYPE:
;;0
;;
;refotype = refo->getproperty(tag='type')
;;print,'refotype=',refotype
;        widget_control,fixvaryphaselist, SET_DROPLIST_SELECT=1
;
;        fixvaryperiodlist = widget_droplist(subBase,$
;                                            title='period',$
;                                            value=['vary','fix'],$
;                                            ysize=25,xsize = 250,$
;                                            uname = 'PHASEIMPORTFIXVARYPERIOD',$
;                                            uvalue = {object:self,$
;                                                      method:'doNothing',$
;                                                      id:'PHASEIMPORTFIXVARYPERIOD',$
;                                                      list:objIndexList})
;        widget_control,fixvaryperiodlist, SET_DROPLIST_SELECT=1
;
;
;
;        allowNegAmpCheckbox = cw_bgroup(subBase,$
;                                        'Allow Small Opposite-Sign Amplitudes',$
;                                        /nonexclusive,$
;                                        /no_release,$
;                                        uname = 'ALLOWNEGATIVEAMPLITUDECHECKBOX',$
;                                        uvalue = {object:self,$
;                                                  method:'doNothing',$
;                                                  id:'ALLOWNEGATIVEAMPLITUDECHECKBOX',$
;                                                  list:objIndexList})
;        forceNegAmpCheckbox = cw_bgroup(subBase,$
;                                        'Force Negative Amplitudes',$
;                                        /nonexclusive,$
;                                        /no_release,$
;                                        uname = 'FORCENEGATIVEAMPLITUDECHECKBOX',$
;                                        uvalue = {object:self,$
;                                                  method:'doNothing',$
;                                                  id:'FORCENEGATIVEAMPLITUDECHECKBOX',$
;                                                  list:objIndexList})
;        widget_control,allownegampcheckbox,set_value=1
;
;        okButton = widget_button(subBase,value = 'OK',$
;                                         xsize=150,ysize=50,$
;                                         uvalue = {object:self,$
;                                                   method:'listEvents',$
;                                                   id:'OKBUTTON',$
;                                                   list:objIndexList})
;        cancelButton = widget_button(subBase,value = 'Cancel',$
;                                             xsize=150,ysize=50,$
;                                             uvalue = {object:self,$
;                                                       method:'listEvents',$
;                                                       id:'CANCELBUTTON',$
;                                                       list:objIndexList})
;
;
;        widget_control,self.phaseImportBase,/realize
;
;
;        ;CREATE DUMMY EVENT STRUCTURE FOR EVENT HANDLING
;        dumEvent = { WIDGET_DROPLIST,$
;                         ID:self.phaseImportBase,$
;                         TOP:self.phaseImportBase,$
;                         HANDLER:0L, INDEX:0L }
;
;        ;STICK EVENT AND OTHER INFORMATION INTO BASE UVALUE
;        widget_control,self.phaseImportBase,set_uvalue=$
;                                            {object:self,$
;                                             method:'listEvents',$
;                                             id:'CANCELBUTTON',$
;                                             list:objIndexList,$
;                                             event:dumEvent}
;
;
;        xmanager,"ooDisplayEcho",self.phaseImportBase,/no_block,$
;                    cleanup='phaseImportBaseCleanup'
;
;    endif else begin
;
;        void = widget_message('No Suitable Data Objects.')
;    endelse
;
;end;definePhaseImportDialog2
;pro ooDisplayEcho::definePhaseImportDialogEventsNew,event
;;
;;NAME:
;;        ooDisplayEcho::definePhaseImportDialogEventsNew
;;
;;PURPOSE:
;;           Handle various "list" events.  These events may come from
;;           phase import, IQT, and set selection dialogs.
;;PARAMETERS:
;;
;;KEYWORDS:
;;
;
;
;;    print,'ListEvent'
;
;    widget_control,event.id,get_uvalue=obj
;
;    case obj.id of
;        'OKBUTTON':begin
;
;                        widget_control,self.phaseImportList,get_uvalue=pil
;                        objIndexList = pil.list
;
;                        index=widget_info(self.phaseImportList,$
;                                            /droplist_select)
;
;
;                        m=self.QChoiceIndex
;                        n=objIndexList[index]
;
;                        objTo = ((self.dataContainer)->get(position=m))
;                        objFrom = ((self.dataContainer)->get(position=n))
;
;                        ;SUPPLY CHECKBOX ON THE PHASE IMPORT WIDGET TO DECIDE IF
;                        ;PHASES WILL BE FIXED.
;
;                        ;NEED TO ASSUME PHASES WILL BE FIXED HERE, UNLESS, SEE ABOVE
;
;                        ;THIS MUST GET THE CURRENT VALUE OF fixed, WHICH TYPICALLY
;                        ;HAS THE PHASE VALUE SET TO VARY.
;                        self.fixed = self->getFixed()
;
;                        savefixed = self.fixed
;
;
;                        ;GET THE FIX/VARY PHASE VALUE FROM THE WIDGET
;                        fixvaryphasedl = widget_info(self.phaseImportBase,$
;                                        find_by_uname='PHASEIMPORTFIXVARYPHASE')
;        ;070505
;        ;NEED THIRD OPTION HERE TO CHOOSE TO FIT THE PHASE OFFSET.
;                        ;self.fixed[2] = widget_info(fixvaryphasedl,/droplist_select)
;                        if widget_info(fixvaryphasedl,/droplist_select) eq 2 then begin
;                            ;FIT PHASE OFFSET
;                            self.fixed[2] = 1
;                            fitphaseoffset = 1
;                        endif else begin
;                            self.fixed[2] = widget_info(fixvaryphasedl,/droplist_select)
;                            fitphaseoffset = 0
;                        endelse
;
;
;                        ;GET THE FIX/VARY PERIOD VALUE FROM THE WIDGET
;                        fixvaryperioddl = widget_info(self.phaseImportBase,$
;                                        find_by_uname='PHASEIMPORTFIXVARYPERIOD')
;
;                        self.fixed[4] = widget_info(fixvaryperioddl,/droplist_select)
;
;                        allownegamp = widget_info(self.phaseImportBase,$
;                                        find_by_uname='ALLOWNEGATIVEAMPLITUDECHECKBOX')
;                        widget_control,allownegamp,get_value=negamp
;
;                        forcenegamp = widget_info(self.phaseImportBase,$
;                                        find_by_uname='FORCENEGATIVEAMPLITUDECHECKBOX')
;                        widget_control,forcenegamp,get_value=forcenegamp
;
;;print,'NEGAMP=',negamp
;
;                        widget_control,self.phaseImportBase,/destroy
;
;                        widget_control,self.atwphase,get_value=sphaseoffset
;                        ;print,sphaseoffset
;                        phaseoffset = double(sphaseoffset)  ;ALWAYS 0.0 SINCE THIS TEXT BOX IS NOT SHOWN.
;                        widget_control,self.atwomega,get_value=somega
;                        ;print,somega
;
;;120904
;;CONVERT PERIOD TO OMEGA.
;;print,omega
;                        omega = 1.0/double(somega)
;
;;print,omega
;                        ;1) GET fixed VALUES FROM GUI AND PASS TO
;                        ;   DATA OBJECT HERE.
;                        ;
;                        ;2) PASS VALUE IN PHASE OFFSET BOX IF NON-ZERO.
;
;                        (self.dataContainer->get(position=$
;                                m))->fitAllFixedPhase,$
;                                objFrom,$
;                                fixed=self.fixed,$
;                                startparms=startparms,$
;                                obj=self,$
;                                phaseoffset = phaseoffset,$
;                                fitphaseoffset=fitphaseoffset,$
;                                omega=omega,$
;                                allownegamp=negamp,$
;                                forcenegamp=forcenegamp
;
;;021406
;;BY POLLING THE DATA OBJECT FOR THE fixed STATE, THERE IS NO NEED TO
;;DO ANYTHING HERE TO HANDLE THE EXTRA fix/vary OPTIONS.
;
;
;                        ;print,self.fixed
;                        ;UPDATE ALL DISPLAYS
;                        self.fixed = savefixed  ;THIS IS IRRELEVANT NOW THAT
;                                                ;"fixed"
;                        self->redefineTree
;                        self->redefineWidgets,self.QChoiceIndex
;                        self->draw
;
;
;                    end
;        'CANCELBUTTON':begin
;                        widget_control,self.phaseImportBase,/destroy
;                    end
;        else:begin
;        endelse
;        endcase
;end;ooDisplayEcho::definePhaseImportDialogEventsNew
        
pro phaseImportBaseCleanupNew_event,event
  
  print,'phaseImportBaseCleanupNew_event'
  help,event,/struct

  widget_control,event.handler,get_uvalue=pstate
  
  case event.id of  
  (*pstate).ok:begin  
    print,'ok'
    widget_control,(*pstate).ALLOWNEGAMPCHECKBOX,get_value=AllowNegAmp
    widget_control,(*pstate).FORCENEGAMPCHECKBOX,get_value=ForceNegAmp

    FixVaryPhase = widget_info((*pstate).FIXVARYPHASELIST,/droplist_select)
    FixVaryPeriod = widget_info((*pstate).FIXVARYPERIODLIST,/droplist_select)

    objIndexList = (*pstate).objIndexList
    widget_control,(*pstate).phaseImportList,get_value=pilVal

    pilvalselect = widget_info((*pstate).phaseImportList,/droplist_select)
    
    ;print,'pilVal=',pilVal[pilvalselect]

    ;print,'objIndexList[pilVal]=',objIndexList[pilValSelect]
    
    ;help,(*pstate).RESULTS,/struct
    (*pstate).RESULTS.doIt = 1
    (*pstate).results.RESINDEX  = objindexlist(pilValSelect);pilValselect
   (*pstate).results.PHASEOPTION = fixVaryPhase
   (*pstate).results.PERIODOPTION = fixVaryPeriod
   (*pstate).results.SMALLOPPOSITEAMPOPTION = AllowNegAmp
   (*pstate).results.FORCENEGATIVEAMP = ForceNegAmp                   
   (*pstate).results.DOIT = 1

    widget_control,(*pstate).tlb,/destroy
    
    ;help,*pstate,/struct
  end;ok
  (*pstate).cancel:begin
    print,'cancel'
    (*pstate).RESULTS.doIt = 0
    widget_control,(*pstate).tlb,/destroy
  end;cancel
  else:
  endcase
end;phaseImportBaseCleanupNew_event
pro PhaseImportBaseCleanupNew,base
;
;NAME:
;        PhaseImportBaseCleanupNew
;
;PURPOSE:
;
;PARAMETERS:
;
;KEYWORDS:
;
;_EXTRA - is used to pass keywords meant for the superclass.

    ;CALLED WHEN [X] EVENT OCCURS.
    print,'pib Cleanup'
    widget_control,base,get_uvalue=pib
;    print,base,self.atlb
    call_method,pib.method,pib.object,pib.event

end;PhaseImportBaseCleanupNew

function ooDisplayEcho::definePhaseImportDialogNew,inputResults
;
;NAME:
;        ooDisplayEcho::definePhaseImportDialogNew
;
;PURPOSE:
;           Create a dialog to select the data object to import phases from
;           for fitting.
;PARAMETERS:
;           none
;KEYWORDS:
;           none


    ;;
    ;
    ;NEED AN EVENT HANDLER TO SET THE SELECTED PHASES
    ;
    ;;;
    currentIndex = inputResults.selectIndex

    refo = self.dataContainer->get(position=currentIndex);self.QChoiceIndex)
    thisFilename = file_basename(refo->getproperty(tag='filename'))
    theList = ['']
    objIndexList = [0]
    for i = 0,self.dataContainer->count()-1 do begin
        refi = self.dataContainer->get(position=i)
        if (refo)->matches(refi) $
                    and (i ne currentIndex) $
                        and (refi->getproperty(tag='type') ne 3) $ ;ONLY SELECT FROM NON-CELL DATA
                            then begin
;                            print,$
;                            (self.dataContainer->get(position=$
;                                i))->getProperty(tag='filename')

                            ;ADD SUCCESSFUL ITEMS TO THE LIST, BUT ADD RESOLUTION FILES TO BEGINNING.
                            if (refi->getproperty(tag='type') eq 1) and $
                                (n_elements(theList) gt 1) then begin
                                theList[0] =file_basename(refi->getProperty(tag='filename'))
                                objIndexList[0] = i
                                theList = $
                                    ['',theList]
                                objIndexList = [0,objIndexList]
                            endif else begin
                                theList = $
                                    [theList,file_basename(refi->getProperty(tag='filename'))]
                                objIndexList = [objIndexList,i]
                            endelse

        endif
    endfor
    if n_elements(theList) gt 1 then begin
        theList = theList[1:*]
        objIndexList = objIndexList[1:*]

        self.phaseImportBase = widget_base(group_leader = self.atlb,$
                                            $;xsize=156,ysize=140,$
                                            /modal,/col,$;/grid_layout,$
                                            title='SELECT PHASE SET for '+thisFilename)

        subBase = widget_base(self.phaseImportBase,/column)
        self.phaseImportList = widget_droplist(subBase,$
                                            value=theList,$
                                            ysize=25,xsize = 250,$
                                            uvalue = {object:self,$
                                                      method:'definePhaseImportDialogEventsNew',$
                                                      id:'PHASEIMPORTLIST',$
                                                      list:objIndexList})

        fixvaryphaselist = widget_droplist(subBase,$
                                            title='phase',$
                                            value=['vary','fix','fit phase offset (constant phase)'],$
                                            ysize=25,xsize = 250,$
                                            uname = 'PHASEIMPORTFIXVARYPHASE',$
                                            uvalue = {object:self,$
                                                      method:'doNothing',$
                                                      id:'PHASEIMPORTFIXVARYPHASE',$
                                                      list:objIndexList})

;111405
;SET FIX/VARY BASED ON OBJ TYPE:
;0
;
refotype = refo->getproperty(tag='type')
;print,'refotype=',refotype
        widget_control,fixvaryphaselist, SET_DROPLIST_SELECT=1

        fixvaryperiodlist = widget_droplist(subBase,$
                                            title='period',$
                                            value=['vary','fix'],$
                                            ysize=25,xsize = 250,$
                                            uname = 'PHASEIMPORTFIXVARYPERIOD',$
                                            uvalue = {object:self,$
                                                      method:'doNothing',$
                                                      id:'PHASEIMPORTFIXVARYPERIOD',$
                                                      list:objIndexList})
        widget_control,fixvaryperiodlist, SET_DROPLIST_SELECT=1



        allowNegAmpCheckbox = cw_bgroup(subBase,$
                                        'Allow Small Opposite-Sign Amplitudes',$
                                        /nonexclusive,$
                                        /no_release,$
                                        uname = 'ALLOWNEGATIVEAMPLITUDECHECKBOX',$
                                        uvalue = {object:self,$
                                                  method:'doNothing',$
                                                  id:'ALLOWNEGATIVEAMPLITUDECHECKBOX',$
                                                  list:objIndexList})
        forceNegAmpCheckbox = cw_bgroup(subBase,$
                                        'Force Negative Amplitudes',$
                                        /nonexclusive,$
                                        /no_release,$
                                        uname = 'FORCENEGATIVEAMPLITUDECHECKBOX',$
                                        uvalue = {object:self,$
                                                  method:'doNothing',$
                                                  id:'FORCENEGATIVEAMPLITUDECHECKBOX',$
                                                  list:objIndexList})
        widget_control,allownegampcheckbox,set_value=1

        okButton = widget_button(subBase,value = 'OK',$
                                         xsize=150,ysize=50,$
                                         uvalue = {object:self,$
                                                   method:'definePhaseImportDialogEventsNew',$
                                                   id:'OKBUTTON',$
                                                   list:objIndexList})
        cancelButton = widget_button(subBase,value = 'Cancel',$
                                             xsize=150,ysize=50,$
                                             uvalue = {object:self,$
                                                       method:'definePhaseImportDialogEventsNew',$
                                                       id:'CANCELBUTTON',$
                                                       list:objIndexList})


        widget_control,self.phaseImportBase,/realize



       state = { tlb:self.phaseImportBase,$
                 ok:okbutton,$
                 cancel:cancelButton,$
                 objIndexList:objIndexList,$
                 theList:theList,$
                 phaseImportList:self.phaseImportList,$
                 allownegampcheckbox:allownegampcheckbox,$
                 forcenegampcheckbox:forcenegampcheckbox,$
                 fixvaryperiodlist:fixvaryperiodlist,$
                 fixvaryphaselist:fixvaryphaselist,$
                 results:inputResults $
                 }
       
        pstate = ptr_new(state)
        ;STICK EVENT AND OTHER INFORMATION INTO BASE UVALUE
        widget_control,self.phaseImportBase,set_uvalue=pstate


        xmanager,"ooDisplayEcho",self.phaseImportBase,$;/no_block,$
                    $;cleanup='phaseImportBaseCleanupNew',
                    event_handler='phaseImportBaseCleanupNew_event'

        ;widget_control,self.phaseimportbase,/destroy

        results = (*pstate).results
        inputResults=results
        ptr_free,pstate
        return,results
    endif else begin

        void = widget_message('No Suitable Data Objects.')
        results = inputResults
        results.doIt = -1
        return,results
    endelse

end;definePhaseImportDialogNew

function ooDisplayEcho::getAtlbOffsets,xoffset=xoffset,yoffset=yoffset
  geom = widget_info(self.atlb,/geometry)
  xoffset = geom.xoffset + geom.xsize/2 - 100
  yoffset = geom.yoffset + geom.ysize/2 - 100

  return,[xoffset,yoffset]
end;ooDisplayEcho::getAtlbOffsets

function ooDisplayEcho::handleTreeContextMultipleSelectFIT_ALL_SETS_WITH_SAME_RESOLUTION,selected,refids
  print,'ooDisplayEcho::handleTreeContextMultipleSelectFIT_ALL_SETS_WITH_SAME_RESOLUTION'
  print,selected,refids

;  self->definePhaseImportDialog2
;  self->importPhases

  results = {selectIndex:0,resIndex:-1,phaseOption:1,periodOption:1,$
             smallOppositeAmpOption:1,ForceNegativeAmp:0,doIt:0}                 
  results = replicate(results,n_elements(selected))  


;  info = MultiselectDefinePhaseImportDialog(selected,self.datacontainer,self.atlb)
;  help,info,/struct
;  print,info
      for i=0,n_elements(selected)-1 do begin

          results[i].selectIndex = selected[i]
          input = results[i]
          duh = self->definePhaseImportDialogNew(input)
          print,input
          results[i] = input
;          help,duh
;          if duh eq -1 then begin
;            results[i].doIt = 0
;          endif else begin
;            results[i] = duh
;          endelse

          ;LRK - 12/09/08
          ;NOW INSTEAD OF SETTING THE TYPE I CALL THE FITALL ROUTINE. 

;          ref = self.datacontainer->get(position=selected[i])

;  1) GET MATCHING OBJECTS
;  
;    2) CREATE PHASE INPUT DIALOG
;    3) GET RESULTS FROM DIALOG
;    4) STORE RESULTS FOR BATCH PROCESSING
;    
;  5) PROCESS ALL THE SELECTED ITEMS WITH THE INPUT PARAMETERS.


          ;print,i,selected[i],'ooDisplayEcho::handleMultipleTreeSelect  --- USED KEYWORDS OR EVENT OPTION TO CHOOSE HANDLING OPTION'
          ;help,event,/structure
          ;ref->storeFitparms
          ;ref_tavestate = ref->report_timeaverage_state()
          ;ref->arcFit,tavestate=ref_tavestate
          
          
          
 ;         help,ref,output=refid
 ;         refseg = (strsplit(refid,'=',/extract))[1]
 ;         refids[i] = refseg
      endfor;i
      
      
      print,'results=',results
      
      ;NOW START THE FITTING:
      offsets = self->getAtlbOffsets()      
      prog = nse_cwo_progress(labels=['Data Set:'],$
                             startvalues=[0L],$
                             endvalues=[long(n_elements(results))],$
                             values=[0L],$
                             steps=[1L],$
                             obj=progobj,$
                             title='Fit with Imported Phases:   ',$
                             xoffset=offsets[0],yoffset=offsets[1]-150)

      for i=0,n_elements(results)-1 do begin
        help,results[i],/struct
        self.fixed = self->getFixed()
        savefixed = self.fixed
        progobj->step,0
        stopped = progobj->checkStop()
        if stopped ne 0 then begin          
          widget_control,prog,/destroy
          return,0
        endif;stopped
        
        if results[i].doIt eq 1 then begin
                        widget_control,self.atwphase,get_value=sphaseoffset
                        phaseoffset = double(sphaseoffset)  ;ALWAYS 0.0 SINCE THIS TEXT BOX IS NOT SHOWN.
                        widget_control,self.atwomega,get_value=somega
                        omega = 1.0/double(somega)
                        fixed = self.fixed
                        if results[i].phaseOption eq 2 then begin
                            ;FIT PHASE OFFSET
                            self.fixed[2] = 1
                            fitphaseoffset = 1
                        endif else begin
                            self.fixed[2] = results[i].phaseoption
                            fitphaseoffset = 0
                        endelse


                        self.fixed[4] = results[i].periodOption
                        
                        currentPosition = results[i].selectIndex
                        objfrom = self.dataContainer->get(position=results[i].resindex)

;022210
;CHECK THE INPUTS
help,currentPosition,objfrom,self.fixed,startparms,self,phaseoffset,fitphaseoffset,omega,$
     results[i].smalloppositeampoption,results[i].forcenegativeamp
                        (self.dataContainer->get(position=$
                                currentPosition))->fitAllFixedPhase,$
                                objFrom,$
                                fixed=self.fixed,$
                                startparms=startparms,$
                                obj=self,$
                                phaseoffset = phaseoffset,$
                                fitphaseoffset=fitphaseoffset,$
                                omega=omega,$
                                allownegamp=results[i].smalloppositeampoption,$
                                forcenegamp=results[i].forcenegativeamp
        endif;results[i]
        self.fixed = savefixed                                
      endfor;i
      if widget_info(prog,/valid_id) then widget_control,prog,/destroy
  return,1
end;ooDisplayEcho::handleTreeContextMultipleSelectFIT_ALL_SETS_WITH_SAME_RESOLUTION
function ooDisplayEcho::handleTreeContextMultipleSelectFIT_ALL_AS_RESOLUTION,selected,refids
  print,'ooDisplayEcho::handleTreeContextMultipleSelectFIT_ALL_AS_RESOLUTION'
  print,selected,refids
      for i=0,n_elements(selected)-1 do begin

          ;LRK - 12/09/08
          ;NOW INSTEAD OF SETTING THE TYPE I CALL THE FITALL ROUTINE. 

          ref = self.datacontainer->get(position=selected[i])

          ;print,i,selected[i],'ooDisplayEcho::handleMultipleTreeSelect  --- USED KEYWORDS OR EVENT OPTION TO CHOOSE HANDLING OPTION'
          ;help,event,/structure
          ref->storeFitparms
          ref_tavestate = ref->report_timeaverage_state()
          widget_control,self.atwwidth,get_value=myWidth
          widget_control,self.atwperiod,get_value=myPeriod

          ref->arcFit,tavestate=ref_tavestate,$
                      sigma=myWidth,$
                      period=myperiod
  
          
          
          help,ref,output=refid,struct=0
          refseg = (strsplit(refid,'=',/extract))[1]
          refids[i] = refseg
      endfor;i
  return,1
end





function ooDisplayEcho::handleTreeContextMultipleSelectMERGE_SELECTED,selected,refids

  ;MERGE ALL SELECTED OBJECTS INTO A SINGLE NEW DATA OBJECT AND ADD IT TO THE DATA CONTAINER.
  if n_elements(selected) gt 1 then begin
    selected = selected[sort(selected)]
    ref = (self.dataContainer->get(position=selected[0]))

    Type = ref->getProperty(tag='type')
    Q = ref->getProperty(tag='q')
    X_dim = ref->getProperty(tag='x_dim')
    Y_dim = ref->getProperty(tag='y_dim')

    origobj = ref
    newobj = obj_new()

    for i=1,n_elements(selected)-1 do begin

        thisref = (self.dataContainer->get(position=selected[i]))

        myType = thisref->getProperty(tag='type')
        myQ = thisref->getProperty(tag='q')
        myX_dim = thisref->getProperty(tag='x_dim')
        myY_dim = thisref->getProperty(tag='y_dim')

        ;VALIDATE OBJECTS
        mergeable = 0
        if (myType eq Type) or (myType eq 0) then begin
            if (myQ eq Q) then begin
                if (myX_dim eq X_dim) and (myY_dim eq Y_dim) then begin        
                  mergeable = 1
                endif;dimension check
            endif;Q check
        endif;type check
        
        ;IF MERGEABLE THEN MERGE ELSE EXIT
        if mergeable eq 1 then begin
          newObj = origobj->merge(thisref)
          if i gt 1 then obj_destroy,origobj  ;DESTROY THE ORIGINAL OBJECT IF IT WAS CREATED IN THIS METHOD.
          origobj = newobj          
        endif else begin          
          void = dialog_message('Unable to merge due to type, binning or q differences.',dialog_parent=self.atlb)
          if obj_valid(newobj) gt 0 then obj_destroy,newobj
          return,0
        endelse
    endfor;i
    
  endif else begin
     void = dialog_message('SELECT MULTIPLED OBJECTS FOR MERGING',dialog_parent=self.atlb)
     return,0
  endelse

  
  if obj_valid(newobj) gt 0 then begin
    self.datacontainer->add,newobj
  endif
  return,1
end;ooDisplayEcho::handleTreeContextMultipleSelectMERGE_SELECTED


function ooDisplayEcho::handleTreeContextMultipleSelectSET_TYPE_TO_UNTYPED,selected,refids
  print,selected,refids
  print,'ooDisplayEcho::handleTreeContextMultipleSelectSET_TYPE_TO_UNTYPED'
      for i=0,n_elements(selected)-1 do begin

          ;LRK - 12/09/08
          ;NOW INSTEAD OF SETTING THE TYPE I CALL THE FITALL ROUTINE. 

          ref = self.datacontainer->get(position=selected[i])

          ;print,i,selected[i],'ooDisplayEcho::handleMultipleTreeSelect  --- USED KEYWORDS OR EVENT OPTION TO CHOOSE HANDLING OPTION'
          ;help,event,/structure
          ;ref->storeFitparms
          ;ref_tavestate = ref->report_timeaverage_state()
          ;ref->arcFit,tavestate=ref_tavestate
          ref->setproperty,'type',0
          
          
          help,ref,output=refid,struct=0
          refseg = (strsplit(refid,'=',/extract))[1]
          refids[i] = refseg
      endfor;i
  print,selected,refids
  return,1
end
function ooDisplayEcho::handleTreeContextMultipleSelectSET_TYPE_TO_RESOLUTION,selected,refids
  print,'ooDisplayEcho::handleTreeContextMultipleSelectSET_TYPE_TO_RESOLUTION'
     for i=0,n_elements(selected)-1 do begin

          ;LRK - 12/09/08
          ;NOW INSTEAD OF SETTING THE TYPE I CALL THE FITALL ROUTINE. 

          ref = self.datacontainer->get(position=selected[i])

          ;print,i,selected[i],'ooDisplayEcho::handleMultipleTreeSelect  --- USED KEYWORDS OR EVENT OPTION TO CHOOSE HANDLING OPTION'
          ;help,event,/structure
          ;ref->storeFitparms
          ;ref_tavestate = ref->report_timeaverage_state()
          ;ref->arcFit,tavestate=ref_tavestate
          ref->setproperty,'type',1
          
          
          help,ref,output=refid,struct=0
          refseg = (strsplit(refid,'=',/extract))[1]
          refids[i] = refseg
      endfor;i
  print,selected,refids
  return,1
end
function ooDisplayEcho::handleTreeContextMultipleSelectSET_TYPE_TO_SAMPLE,selected,refids
  print,'ooDisplayEcho::handleTreeContextMultipleSelectSET_TYPE_TO_SAMPLE'
     for i=0,n_elements(selected)-1 do begin

          ;LRK - 12/09/08
          ;NOW INSTEAD OF SETTING THE TYPE I CALL THE FITALL ROUTINE. 

          ref = self.datacontainer->get(position=selected[i])

          ;print,i,selected[i],'ooDisplayEcho::handleMultipleTreeSelect  --- USED KEYWORDS OR EVENT OPTION TO CHOOSE HANDLING OPTION'
          ;help,event,/structure
          ;ref->storeFitparms
          ;ref_tavestate = ref->report_timeaverage_state()
          ;ref->arcFit,tavestate=ref_tavestate
          ref->setproperty,'type',2
          
          
          help,ref,output=refid,struct=0
          refseg = (strsplit(refid,'=',/extract))[1]
          refids[i] = refseg
      endfor;i
  print,selected,refids

  print,selected,refids

  return,1
end
function ooDisplayEcho::handleTreeContextMultipleSelectSET_TYPE_TO_CELL,selected,refids
  print,'ooDisplayEcho::handleTreeContextMultipleSelectSET_TYPE_TO_CELL'
  print,selected,refids
     for i=0,n_elements(selected)-1 do begin

          ;LRK - 12/09/08
          ;NOW INSTEAD OF SETTING THE TYPE I CALL THE FITALL ROUTINE. 

          ref = self.datacontainer->get(position=selected[i])

          ;print,i,selected[i],'ooDisplayEcho::handleMultipleTreeSelect  --- USED KEYWORDS OR EVENT OPTION TO CHOOSE HANDLING OPTION'
          ;help,event,/structure
          ;ref->storeFitparms
          ;ref_tavestate = ref->report_timeaverage_state()
          ;ref->arcFit,tavestate=ref_tavestate
          ref->setproperty,'type',3
          
          
          help,ref,output=refid,struct=0
          refseg = (strsplit(refid,'=',/extract))[1]
          refids[i] = refseg
      endfor;i
  print,selected,refids
  return,1
end
function ooDisplayEcho::handleTreeContextMultipleSelectSET_IMPORTED_MASK_TO,selected,refids
  print,'ooDisplayEcho::handleTreeContextMultipleSelectSET_IMPORTED_MASK_TO'
  print,selected,refids
  return,1
end
function ooDisplayEcho::handleTreeContextMultipleSelectSET_PARAMETER_VALUES_TO,selected,refids
  print,'ooDisplayEcho::handleTreeContextMultipleSelectSET_PARAMETER_VALUES_TO'
  print,selected,refids
  return,1
end
function ooDisplayEcho::handleTreeContextMultipleSelectSET_RESOLUTION_FILE_TO,selected,refids
  print,'ooDisplayEcho::handleTreeContextMultipleSelectSET_RESOLUTION_FILE_TO'
  print,selected,refids
  return,1
end
function ooDisplayEcho::handleTreeContextMultipleSelectSET_CELL_FILE_TO,selected,refids
  print,selected,refids
  print,'ooDisplayEcho::handleTreeContextMultipleSelectSET_CELL_FILE_TO'
  return,1
end

pro ooDisplayEcho::handleTreeContextMultipleSelect,event
  print,'ooDisplayEcho::handleTreeContextMultipleSelect'
  widget_control,event.id,get_uvalue=uval
  print,uval.id
  help,uval,/struct
          sel_id = widget_info(self.ftree,/tree_select)
  
          ;REMOVE FOLDER ID'S
          selectindices = [-1]
          for i=0,n_elements(sel_id)-1 do begin
              widget_control,sel_id[i],get_uvalue=sel_uval
              ;ONLY USE FILES, NOT FOLDERS
              if sel_uval.id eq 'FTW' then begin
                  selectindices = [selectindices,sel_uval.index]
              endif
          end;i

          ;NOW LOOK AT NON-FOLDER SELECTIONS:
          if n_elements(selectindices) gt 1 then begin
              selectindices = selectindices[1:*]

              selected = reverse(selectindices[sort(selectindices)])

              ;NOW REMOVE THE OBJECTS FROM THE END TO THE BEGINNING.
              refids = strarr(n_elements(selected))
              
              case strupcase(uval.id) of
              ;'':self->,selected,refids
              'REMOVEMULTIPLEOBJ':begin
                print,uval.id ;SORT AND THEN REMOVE HIGHEST POSITION FIRST.  NO NEED TO STORE REFID'S SINCE THESE ITEMS REMOVED.
                                                ;ACCOUNT FOR THIS BELOW.
                success = self->handleTreeContextMultipleSelectREMOVEMULTIPLEOBJ(selected,refids)
              end                                                
              'FIT_ALL_SETS_WITH_SAME_RESOLUTION':begin
                print,uval.id
                success = self->handleTreeContextMultipleSelectFIT_ALL_SETS_WITH_SAME_RESOLUTION(selected,refids)
              end                                                
              'FIT_ALL_AS_RESOLUTION':begin
                print,uval.id
                success = self->handleTreeContextMultipleSelectFIT_ALL_AS_RESOLUTION(selected,refids)
              end
              'MERGE_SELECTED':begin
                success = self->handleTreeContextMultipleSelectMERGE_SELECTED(selected,refids)
              end;MERGE_SELECTED
              'SET_TYPE_TO_UNTYPED':begin
                ;print,'HEY, SET_TYPE_TO_UNTYPED!'
                ;print,uval.id
                success = self->handleTreeContextMultipleSelectSET_TYPE_TO_UNTYPED(selected,refids)
              end                                                
              'SET_TYPE_TO_RESOLUTION':begin
                print,uval.id
                success = self->handleTreeContextMultipleSelectSET_TYPE_TO_RESOLUTION(selected,refids)
              end                                                
              'SET_TYPE_TO_SAMPLE':begin
                print,uval.id
                success = self->handleTreeContextMultipleSelectSET_TYPE_TO_SAMPLE(selected,refids)
              end                                                
              'SET_TYPE_TO_CELL':begin
                success = self->handleTreeContextMultipleSelectSET_TYPE_TO_CELL(selected,refids)
                print,uval.id
              end
              'SET_IMPORTED_MASK_TO':begin
                print,uval.id
                success = self->handleTreeContextMultipleSelectSET_IMPORTED_MASK_TO(selected,refids)
              end                                                
              'SET_PARAMETER_VALUES_TO':begin
                print,uval.id
                success = self->handleTreeContextMultipleSelectSET_PARAMETER_VALUES_TO(selected,refids)
              end                                                
              'SET_RESOLUTION_FILE_TO':begin
                print,uval.id
                success = self->handleTreeContextMultipleSelectSET_RESOLUTION_FILE_TO(selected,refids)
              end                                                
              'SET_CELL_FILE_TO':begin
                print,uval.id
                success = self->handleTreeContextMultipleSelectSET_CELL_FILE_TO(selected,refids)
              end                                                
              else:begin
                print,uval.id
                success = 1
              endelse
              endcase
              
              print,'success=',success
              
              ;START A COUNTER
              
;              for i=0,n_elements(selected)-1 do begin
;
;                  ;LRK - 12/09/08
;                  ;NOW INSTEAD OF SETTING THE TYPE I CALL THE FITALL ROUTINE. 
;
;                  ref = self.datacontainer->get(position=selected[i])
;
;                  ;print,i,selected[i],'ooDisplayEcho::handleMultipleTreeSelect  --- USED KEYWORDS OR EVENT OPTION TO CHOOSE HANDLING OPTION'
;                  ;help,event,/structure
;                  ;ref->storeFitparms
;                  ;ref_tavestate = ref->report_timeaverage_state()
;                  ;ref->arcFit,tavestate=ref_tavestate
;          
;                  
;                  
;                  help,ref,output=refid
;                  refseg = (strsplit(refid,'=',/extract))[1]
;                  refids[i] = refseg
;              endfor;i
          endif
          self->redefinetree


          tids = widget_info(self.ftree,/all_children)
          allids = [-1]

          if tids[0] gt 0 then begin
            for i=0,n_elements(tids)-1 do begin
              ctids = widget_info(tids[i],/all_children)
              allids = [allids,ctids]  
            endfor;i
            if n_elements(allids) gt 1 then allids = allids[1:*]
            for i=0,n_elements(allids)-1 do begin
              widget_control,allids[i],get_uvalue=uval
              tags = tag_names(uval)
              help,uval.dataobject,output=nowout,struct=0
              nowsegs = strsplit(nowout,'=',/extract)
              match = where(nowsegs[1] eq refids)
              if match[0] ne -1 then widget_control,allids[i],set_tree_select=1
            
            endfor;i
          endif



end;ooDisplayEcho::handleMultipleTreeSelect



pro ooDisplayEcho::autoFitAllResolution,event
  print,'REMOVE THIS LATER, IT IS ONLY BECAUSE I HAD A TYPO DURING TESTING'
  self->autoFitAllAsResolution,event
end;pro ooDisplayEcho::autoFitAllResolution
pro ooDisplayEcho::autoFitAllAsResolution,event
  print,'ooDisplayEcho::autoFitAllAsResolution'
  help,event,/struct  

          sel_id = widget_info(self.ftree,/tree_select)
  
          ;REMOVE FOLDER ID'S
          selectindices = [-1]
          for i=0,n_elements(sel_id)-1 do begin
              widget_control,sel_id[i],get_uvalue=uval
              ;ONLY USE FILES, NOT FOLDERS
              if uval.id eq 'FTW' then begin
                  selectindices = [selectindices,uval.index]
              endif
          end;i

          ;NOW LOOK AT NON-FOLDER SELECTIONS:
          if n_elements(selectindices) gt 1 then begin
              selectindices = selectindices[1:*]

              selected = reverse(selectindices[sort(selectindices)])

              ;NOW REMOVE THE OBJECTS FROM THE END TO THE BEGINNING.
              refids = strarr(n_elements(selected))
              ;START A COUNTER
              
              for i=0,n_elements(selected)-1 do begin

                  ;LRK - 12/09/08
                  ;NOW INSTEAD OF SETTING THE TYPE I CALL THE FITALL ROUTINE. 

                  ref = self.datacontainer->get(position=selected[i])

                  

                  ref->storeFitparms
                  ref_tavestate = ref->report_timeaverage_state()
                  ref->arcFit,tavestate=ref_tavestate
          
                  
                  
                  help,ref,output=refid,struct=0
                  refseg = (strsplit(refid,'=',/extract))[1]
                  refids[i] = refseg
              endfor;i
          endif
          self->redefinetree


          tids = widget_info(self.ftree,/all_children)
          allids = [-1]
          for i=0,n_elements(tids)-1 do begin
            ctids = widget_info(tids[i],/all_children)
            allids = [allids,ctids]  
          endfor;i
          if n_elements(allids) gt 1 then allids = allids[1:*]
          for i=0,n_elements(allids)-1 do begin
            widget_control,allids[i],get_uvalue=uval
            tags = tag_names(uval)
            help,uval.dataobject,output=nowout,struct=0
            nowsegs = strsplit(nowout,'=',/extract)
            match = where(nowsegs[1] eq refids)
            if match[0] ne -1 then widget_control,allids[i],set_tree_select=1
          
          endfor;i



end;ooDisplayEcho::autoFitAllAsResolution
pro ooDisplayEcho::setAllToUntyped,event

          sel_id = widget_info(self.ftree,/tree_select)
  
          ;REMOVE FOLDER ID'S
          selectindices = [-1]
          for i=0,n_elements(sel_id)-1 do begin
              widget_control,sel_id[i],get_uvalue=uval
              ;ONLY USE FILES, NOT FOLDERS
              if uval.id eq 'FTW' then begin
                  selectindices = [selectindices,uval.index]
              endif
          end;i

          ;NOW LOOK AT NON-FOLDER SELECTIONS:
          if n_elements(selectindices) gt 1 then begin
              selectindices = selectindices[1:*]

              selected = reverse(selectindices[sort(selectindices)])

              ;NOW REMOVE THE OBJECTS FROM THE END TO THE BEGINNING.
              refids = strarr(n_elements(selected))
              for i=0,n_elements(selected)-1 do begin
                  ref = self.datacontainer->get(position=selected[i])
                  ref->setProperty,'type',0
                  help,ref,output=refid,struct=0
                  refseg = (strsplit(refid,'=',/extract))[1]
                  refids[i] = refseg
              endfor;i
          endif
          self->redefinetree


          tids = widget_info(self.ftree,/all_children)
          allids = [-1]
          for i=0,n_elements(tids)-1 do begin
            ctids = widget_info(tids[i],/all_children)
            allids = [allids,ctids]  
          endfor;i
          if n_elements(allids) gt 1 then allids = allids[1:*]
          for i=0,n_elements(allids)-1 do begin
            widget_control,allids[i],get_uvalue=uval
            tags = tag_names(uval)
            help,uval.dataobject,output=nowout,struct=0
            nowsegs = strsplit(nowout,'=',/extract)
            match = where(nowsegs[1] eq refids)
            if match[0] ne -1 then widget_control,allids[i],set_tree_select=1
          
          endfor;i


end;ooDisplayEcho::setAllToUnTyped
pro ooDisplayEcho::setAllToResolution,event
  print,'ooDisplayEcho::setAllToResolution' 
          sel_id = widget_info(self.ftree,/tree_select)
  
          ;REMOVE FOLDER ID'S
          selectindices = [-1]
          for i=0,n_elements(sel_id)-1 do begin
              widget_control,sel_id[i],get_uvalue=uval
              ;ONLY USE FILES, NOT FOLDERS
              if uval.id eq 'FTW' then begin
                  selectindices = [selectindices,uval.index]
              endif
          end;i

          ;NOW LOOK AT NON-FOLDER SELECTIONS:
          if n_elements(selectindices) gt 1 then begin
              selectindices = selectindices[1:*]

              selected = reverse(selectindices[sort(selectindices)])

              ;NOW REMOVE THE OBJECTS FROM THE END TO THE BEGINNING.
              refids = strarr(n_elements(selected))
              for i=0,n_elements(selected)-1 do begin
                  ref = self.datacontainer->get(position=selected[i])
                  ref->setProperty,'type',1
                  help,ref,output=refid,struct=0
                  refseg = (strsplit(refid,'=',/extract))[1]
                  refids[i] = refseg
              endfor;i
          endif
          self->redefinetree


          tids = widget_info(self.ftree,/all_children)
          allids = [-1]
          for i=0,n_elements(tids)-1 do begin
            ctids = widget_info(tids[i],/all_children)
            allids = [allids,ctids]  
          endfor;i
          if n_elements(allids) gt 1 then allids = allids[1:*]
          for i=0,n_elements(allids)-1 do begin
            widget_control,allids[i],get_uvalue=uval
            tags = tag_names(uval)
            help,uval.dataobject,output=nowout,struct=0
            nowsegs = strsplit(nowout,'=',/extract)
            match = where(nowsegs[1] eq refids)
            if match[0] ne -1 then widget_control,allids[i],set_tree_select=1
          
          endfor;i

end;ooDisplayEcho::setAllToResolution
pro ooDisplayEcho::setAllToSample,event
  print,'ooDisplayEcho::setAllToSample' 
          sel_id = widget_info(self.ftree,/tree_select)
  
  
          ;REMOVE FOLDER ID'S
          selectindices = [-1]
          for i=0,n_elements(sel_id)-1 do begin
              widget_control,sel_id[i],get_uvalue=uval
              ;ONLY USE FILES, NOT FOLDERS
              if uval.id eq 'FTW' then begin
                  selectindices = [selectindices,uval.index]
              endif
          end;i

          ;NOW LOOK AT NON-FOLDER SELECTIONS:
          if n_elements(selectindices) gt 1 then begin
              selectindices = selectindices[1:*]

              selected = reverse(selectindices[sort(selectindices)])

              ;NOW REMOVE THE OBJECTS FROM THE END TO THE BEGINNING.
              refids = strarr(n_elements(selected))
              for i=0,n_elements(selected)-1 do begin
                  ref = self.datacontainer->get(position=selected[i])
                  ref->setProperty,'type',2
                  help,ref,output=refid,struct=0
                  refseg = (strsplit(refid,'=',/extract))[1]
                  refids[i] = refseg
              endfor;i
          endif
          self->redefinetree


print,'self.ftree=',self.ftree
tids = widget_info(self.ftree,/all_children)
allids = [-1]
for i=0,n_elements(tids)-1 do begin
  ;print,'i,tids children=',i,widget_info(tids[i],/all_children)
  ctids = widget_info(tids[i],/all_children)
  allids = [allids,ctids]  
endfor;i
;print,'alltids=',allids
if n_elements(allids) gt 1 then allids = allids[1:*]
;print,allids
;refs = self.datacontainer->get(/all)
;for i=0,n_elements(refs)-1 do begin
;  
;  help,refs[i],output=out
;  outseg = (strsplit(out,'=',/extract))[1]
;  match = where(outseg eq refids)
;  if match ne -1 then widget_control,
;endfor;i

for i=0,n_elements(allids)-1 do begin
  widget_control,allids[i],get_uvalue=uval
  tags = tag_names(uval)


  ;LRK 120508
  ;ADDED THE TAG dataObject TO EACH OF THE BOTTOM LEAF uvalues. 
  ;NOW THE SEARCH FOR SELECTIONS WORKS WITHOUT CHANGING THE FUNCTIONALITY!!!!
  ;NOW APPLY THIS TO ALL OF THE OPERATIONS!!!!!!!
  help,uval.dataobject,output=nowout,struct=0
  nowsegs = strsplit(nowout,'=',/extract)
  match = where(nowsegs[1] eq refids)
  print,match,nowsegs[1],refids
  if match[0] ne -1 then widget_control,allids[i],set_tree_select=1

endfor;i

end;ooDisplayEcho::setAllToSample
pro ooDisplayEcho::setAllToCell,event
  print,'____________________________________________________'
  print,'ooDisplayEcho::setAllToCell' 
          sel_id = widget_info(self.ftree,/tree_select)
  
          ;REMOVE FOLDER ID'S
          selectindices = [-1]
          for i=0,n_elements(sel_id)-1 do begin
              widget_control,sel_id[i],get_uvalue=uval
              ;ONLY USE FILES, NOT FOLDERS
              if uval.id eq 'FTW' then begin
                  selectindices = [selectindices,uval.index]
              endif
          end;i

          ;NOW LOOK AT NON-FOLDER SELECTIONS:
          if n_elements(selectindices) gt 1 then begin
              selectindices = selectindices[1:*]

              selected = reverse(selectindices[sort(selectindices)])

              ;NOW REMOVE THE OBJECTS FROM THE END TO THE BEGINNING.
              refids = strarr(n_elements(selected))
              for i=0,n_elements(selected)-1 do begin
                  ref = self.datacontainer->get(position=selected[i])
                  ref->setProperty,'type',3
                  help,ref,output=refid,struct=0
                  refseg = (strsplit(refid,'=',/extract))[1]
                  refids[i] = refseg
              endfor;i
          endif
          self->redefinetree


tids = widget_info(self.ftree,/all_children)
allids = [-1]
for i=0,n_elements(tids)-1 do begin
  ctids = widget_info(tids[i],/all_children)
  allids = [allids,ctids]  
endfor;i
if n_elements(allids) gt 1 then allids = allids[1:*]
for i=0,n_elements(allids)-1 do begin
  widget_control,allids[i],get_uvalue=uval
  tags = tag_names(uval)
  help,uval.dataobject,output=nowout,struct=0
  nowsegs = strsplit(nowout,'=',/extract)
  match = where(nowsegs[1] eq refids)
  if match[0] ne -1 then widget_control,allids[i],set_tree_select=1

endfor;i

    
end;ooDisplayEcho::setAllToCell
pro ooDisplayEcho::setImportedMaskTo,event
  print,'ooDisplayEcho::setImportedMaskTo' 
  help,event,/struct  
end;ooDisplayEcho::setImportedMaskTo
pro ooDisplayEcho::setParameterValuesTo,event
  print,'ooDisplayEcho::setParameterValuesTo' 
  help,event,/struct  
end;ooDisplayEcho::setParameterValuesTo
pro ooDisplayEcho::setResolutionFileTo,event
  print,'ooDisplayEcho::setResolutionFileTo' 
  help,event,/struct  
  
end;ooDisplayEcho::setResolutionFileTo
pro ooDisplayEcho::setCellFileTo,event
  
  print,'_______________________________________________________'
  print,'*******************************************************'
  print,'ooDisplayEcho::setCellFileTo' 
  help,event,/struct  
  
          sel_id = widget_info(self.ftree,/tree_select)
  
  
          ;REMOVE FOLDER ID'S
          selectindices = [-1]
          for i=0,n_elements(sel_id)-1 do begin
              widget_control,sel_id[i],get_uvalue=uval
              ;ONLY USE FILES, NOT FOLDERS
              if uval.id eq 'FTW' then begin
                  selectindices = [selectindices,uval.index]
              endif
          end;i

          ;NOW LOOK AT NON-FOLDER SELECTIONS:
          if n_elements(selectindices) gt 1 then begin
              selectindices = selectindices[1:*]

              selected = reverse(selectindices[sort(selectindices)])

              ;NOW REMOVE THE OBJECTS FROM THE END TO THE BEGINNING.
              for i=0,n_elements(selected)-1 do begin
                  PRINT,'SELECT THE OBJECT AND DO THE ACTION!!!!'
                  print,selected[i]
                  ref = self.datacontainer->get(position=selected[i])
                  comm = ref->getproperty(tag='comment')
                  print,comm 
                  ;self->remove,dataObjIndex=selected[i]
              endfor;i
          endif

  
  print,'_______________________________________________________'
  print,'*******************************************************'
  
  
end;ooDisplayEcho::setCellFileTo



pro ooDisplayEcho::defineContextMenus
;
;NAME:
;        ooDisplayEcho::defineContextMenus
;
;PURPOSE:
;
;PARAMETERS:
;
;KEYWORDS:
;
;_EXTRA - is used to pass keywords meant for the superclass.


    ;
    ;
    ;UPDATE THIS TO DEAL WITH THE CONCEPT OF SETS.
    ;
    ;

    contextBaseS = widget_base(self.atlb,/context_menu,uname='STW_MENU',/col)
    button1S = widget_button(contextBaseS,value='CALCULATE I(Q,t)',$
                                        uvalue = {object:self,$
                                                  method:'contextMenuEvents',$
                                                  id:'SETIQTCALC'})
    button2S = widget_button(contextBaseS,value='Change Name',$
                                        uvalue = {object:self,$
                                                  method:'contextMenuEvents',$
                                                  id:'SETCHANGENAME'})
    button3S = widget_button(contextBaseS,value='Remove Set',$
                                        uvalue = {object:self,$
                                                  method:'contextMenuEvents',$
                                                  id:'SETREMOVESET'})
;    button4S = widget_button(contextBaseS,value='Remove Object From Set',$
;                                        uvalue = {object:self,$
;                                                  method:'contextMenuEvents',$
;                                                  id:'SETREMOVEOBJECT'})
;    button5S = widget_button(contextBaseS,value='Change Q Value ',$
;                                        uvalue = {object:self,$
;                                                  method:'contextMenuEvents',$
;                                                  id:'SETSETQVALUE'})



;###########################################################################################
;022406
;
    contextBaseF_multi = WIDGET_BASE(self.atlb, /CONTEXT_MENU,uname='FTW_MULTI_MENU',$
                                     kill_notify='oodisplayecho_contextmenudestroy',/col)

    noInfoMulti = widget_button(contextBaseF_multi,value='REMOVE SELECTED DATASETS',$
                                            uvalue = {object:self,$
                                                  method:'handleTreeContextMultipleSelect',$;'contextMenuEvents',$
                                                  id:'REMOVEMULTIPLEOBJ'})

    noInfoMulti = widget_button(contextBaseF_multi,value='FIT_ALL_SETS_WITH_IMPORTED_PHASES',$
                                            uvalue = {object:self,$
                                                  method:'handleTreeContextMultipleSelect',$;'contextMenuEvents',$
                                                  id:'FIT_ALL_SETS_WITH_SAME_RESOLUTION'})

    noInfoMulti = widget_button(contextBaseF_multi,value='FIT ALL AS RESOLUTION',$
                                            uvalue = {object:self,$
                                                  method:'handleTreeContextMultipleSelect',$;'autoFitAllAsResolution',$
                                                  id:'FIT_ALL_AS_RESOLUTION'})


    typeMulti = widget_button(contextBaseF_multi,value='SET TYPE TO:',/menu)
    
    noInfoMulti = widget_button(typeMulti,value='UNTYPED',$
                                            uvalue = {object:self,$
                                                  method:'handleTreeContextMultipleSelect',$;'setAllToUntyped',$
                                                  id:'SET_TYPE_TO_UNTYPED'})

    noInfoMulti = widget_button(typeMulti,value='RESOLUTION',$
                                            uvalue = {object:self,$
                                                  method:'handleTreeContextMultipleSelect',$;'setAllToResolution',$
                                                  id:'SET_TYPE_TO_RESOLUTION'})

    noInfoMulti = widget_button(typeMulti,value='SAMPLE',$
                                            uvalue = {object:self,$
                                                  method:'handleTreeContextMultipleSelect',$;'setAllToSample',$
                                                  id:'SET_TYPE_TO_SAMPLE'})

    noInfoMulti = widget_button(typeMulti,value='CELL',$
                                            uvalue = {object:self,$
                                                  method:'handleTreeContextMultipleSelect',$;'setAllToCell',$
                                                  id:'SET_TYPE_TO_CELL'})

    noInfoMulti = widget_button(contextBaseF_multi,value='MERGE ALL SELECTED',$
                                            uvalue = {object:self,$
                                                  method:'handleTreeContextMultipleSelect',$;'autoFitAllAsResolution',$
                                                  id:'MERGE_SELECTED'})


;    noInfoMulti = widget_button(contextBaseF_multi,value='SET IMPORTED MASK TO',$
;                                            uvalue = {object:self,$
;                                                  method:'handleTreeContextMultipleSelect',$;'setImportedMaskTO',$
;                                                  id:'SET_IMPORTED_MASK_TO'})
;
;    noInfoMulti = widget_button(contextBaseF_multi,value='SET PARAMETER VALUES TO',$
;                                            uvalue = {object:self,$
;                                                  method:'handleTreeContextMultipleSelect',$;'setParameterValuesTo',$
;                                                  id:'SET_PARAMETER_VALUES_TO'})
;  
;    noInfoMulti = widget_button(contextBaseF_multi,value='SET RESOLUTION FILE TO',$
;                                            uvalue = {object:self,$
;                                                  method:'handleTreeContextMultipleSelect',$;'setResolutionFileTo',$
;                                                  id:'SET_RESOLUTION_FILE_TO'})
;
;    noInfoMulti = widget_button(contextBaseF_multi,value='SET CELL FILE TO',$
;                                            uvalue = {object:self,$
;                                                  method:'handleTreeContextMultipleSelect',$;'setCellFileTo',$
;                                                  id:'SET_CELL_FILE_TO'})



;WANT TO ADD A MULTIPLE SELECTION CONTEXT MENU
;###########################################################################################


    contextBaseF = WIDGET_BASE(self.atlb, /CONTEXT_MENU,uname='FTW_MENU',kill_notify='oodisplayecho_contextmenudestroy',/col)
    setTypeButton = widget_button(contextBaseF,$
                                        value='Select data set type',/menu)

    button1F = WIDGET_BUTTON(setTypeButton,$;contextBaseF, $
                                        VALUE='Untyped',$
                                        uvalue = {object:self,$
                                                  method:'contextMenuEvents',$
                                                  id:'UNTYPED'})
    button2F = WIDGET_BUTTON(setTypeButton,$;contextBaseF, $
                                        VALUE='Resolution',$
                                        uvalue = {object:self,$
                                                  method:'contextMenuEvents',$
                                                  id:'RESOLUTION'})
    button3F = WIDGET_BUTTON(setTypeButton,$;contextBaseF, $
                                        VALUE='Sample',$
                                        uvalue = {object:self,$
                                                  method:'contextMenuEvents',$
                                                  id:'RAWDATA'})
    button4F = WIDGET_BUTTON(setTypeButton,$;contextBaseF, $
                                        VALUE='Cell',$
                                        uvalue = {object:self,$
                                                  method:'contextMenuEvents',$
                                                  id:'BACKGROUND'})
;050704
;111704
;
;COMMENT OUT A FEW OF THE NEXT BUTTONS FOR NOW
;UNTIL SETS AND MERGING ARE AVAILABLE AND DEBUGGED.

;061505
;;;;
;;;;    setOperationsButton = widget_button(contextBaseF,value='Set Operations',/menu)
;;;;
;;;;    button5F = WIDGET_BUTTON(setOperationsButton,$;contextBaseF, $
;;;;                                        VALUE='Assign Object to a Set',$
;;;;                                        sensitive=0,$
;;;;                                        uvalue = {object:self,$
;;;;                                                  method:'contextMenuEvents',$
;;;;                                                  id:'ASSIGNOBJ'})
;;;;
;;;;    button7F = WIDGET_BUTTON(setOperationsButton,$;contextBaseF, $
;;;;                                        VALUE='Create New Set',$
;;;;                                        sensitive=0,$
;;;;                                        uvalue = {object:self,$
;;;;                                                  method:'contextMenuEvents',$
;;;;                                                  id:'OBJNEWSET'})

    objOperationsButton = widget_button(contextBaseF,value='Dataset Operations',/menu)


    button6Fa = WIDGET_BUTTON(objOperationsButton,$;contextBaseF, $
                                        VALUE='Merge Datasets',$
                                        sensitive=1,$
                                        uvalue = {object:self,$
                                                  method:'contextMenuEvents',$
                                                  id:'MERGEOBJ'})

    button6F = WIDGET_BUTTON(objOperationsButton,$;contextBaseF, $
                                        VALUE='Remove Dataset',$
                                        uvalue = {object:self,$
                                                  method:'contextMenuEvents',$
                                                  id:'REMOVEOBJ'})

    button6F = WIDGET_BUTTON(objOperationsButton,$;contextBaseF, $
                                        VALUE='Duplicate Dataset',$
                                        uvalue = {object:self,$
                                                  method:'contextMenuEvents',$
                                                  id:'DUPLICATEOBJ'})

;LRK 110708
;MOVED THIS OPTION TO THE Dataset OPERATIONS MENU

    ;CHANGE THE NEXT BUTTON TO CALL A LIST WIDGET.
    button6Fb = WIDGET_BUTTON(objOperationsButton, VALUE='Remove Fourier Times',$
                                        sensitive=1,menu=0,$;menu=1,$
                                        uvalue = {object:self,$
                                                  method:'contextMenuEvents',$
                                                  id:'REMOVEFOURIERTIMEMENU'});,$
                                                  ;kill_notify='oodisplayecho_contextmenudestroy')


    file_button1 = widget_button(objOperationsButton,$;contextBaseF,$
                                value='Save Dataset',$
                                uname="SAVEOBJECT",$
                                uvalue={object:self,$
                                        method:'menuEvents',$
                                        id:'SAVEOBJECT',$
                                        parent:'FILEOPTIONS'})

    file_button1 = widget_button(objOperationsButton,$;contextBaseF,$
                                value='Restore Dataset',$
                                uname="RESTOREOBJECT",$
                                uvalue={object:self,$
                                        method:'menuEvents',$
                                        id:'RESTOREOBJECT',$
                                        parent:'FILEOPTIONS'})




;    ;CHANGE THE NEXT BUTTON TO CALL A LIST WIDGET.
;    button6Fb = WIDGET_BUTTON(contextBaseF, VALUE='Remove Fourier Times',$
;                                        sensitive=1,menu=0,$;menu=1,$
;                                        uvalue = {object:self,$
;                                                  method:'contextMenuEvents',$
;                                                  id:'REMOVEFOURIERTIMEMENU'});,$
;                                                  ;kill_notify='oodisplayecho_contextmenudestroy')


    self.removeFourierTimeMenu = button6Fb
    ;print,'oodisplayecho::defineContextMenus self.removeFourierTimeMenu='+string(self.removeFourierTimeMenu)


    ;ADD I(Q,t) CALCULATION BUTTONS TO THE CONTEXT MENUS
;    button8F = widget_button(contextBaseF,$
;                                value='Calculate Q Values',$
;                                uname='CALCULATEQS',$
;                                uvalue={object:self,$
;                                        method:'menuEvents',$
;                                        id:'CALCULATEQS',$
;                                        parent:'CALCULATIONOPTIONS'})


    button8Fit = widget_button(contextBaseF,$
                             $;value = 'Import Phases AND FIT ALL TAU',$
                             value = 'Fit Operations',/menu)
    button8F = widget_button(button8Fit,$;contextBaseF,$
                             $;value = 'Import Phases AND FIT ALL TAU',$
                             value = 'IMPORT PHASES (Sample,Cell)',$
                             $;tooltip = 'Fit all echoes using phases from another data set',$
                             $;ysize=buttonysize,$
                             uvalue={object:self,$
                             method:'buttonEvents',$
                             id:'PHASEIMPORTBUTTON'})
    button8F = widget_button(button8Fit,$;contextBaseF,$
                             $;value = 'Import Phases AND FIT ALL TAU',$
                             value = 'Fit Echoes (Resolution)',$
                             $;tooltip = 'Fit all echoes using phases from another data set',$
                             $;ysize=buttonysize,$
                             uvalue={object:self,$
                                     method:'buttonEvents',$
                                     id:'FITBUTTONALL'})

;    self.fitselector = cwo_pickmethod(leftbase,options,fieldnames,$
;                            ysize=30,$
;                            obj_ref=the_pickmethod_obj_ref,frame=2,$
;                            uvalue={object:self,$
;                                    method:'buttonEvents',$
;                                    id:'FITBUTTONALL'})





    button9F = widget_button(contextBaseF,$
                                value='Calculate I(Q,t)',$
                                uname='CALCULATEI',$
                                uvalue={object:self,$
                                        method:'menuEvents',$
                                        id:'CALCULATEI',$
                                        parent:'CALCULATIONOPTIONS'})

    button9F = widget_button(contextBaseF,$
                                value='Calculate I(Q,t) Express (New and lightly tested)',$
                                uname='CALCULATEIEXPRESS',$
                                uvalue={object:self,$
                                        method:'menuEvents',$
                                        id:'CALCULATEIEXPRESS',$
                                        parent:'CALCULATIONOPTIONS'})


    contextsaveutilities = widget_button(contextBaseF, VALUE='Save Utilities',$
                                        sensitive=1,menu=1,$
                                        uvalue = {object:self,$
                                                  method:'contextMenuEvents',$
                                                  id:'SAVEUTILITIES'});,$

    button6Fb = WIDGET_BUTTON(contextsaveutilities, VALUE='Save Fit Parameters',$
                                        sensitive=1,menu=0,$;menu=1,$
                                        uvalue = {object:self,$
                                                  method:'contextMenuEvents',$
                                                  id:'SAVEFITPARAMETERS'})
    button6Fb = WIDGET_BUTTON(contextsaveutilities, VALUE='Save Data Items',$
                                        sensitive=1,menu=0,$
                                        uvalue = {object:self,$
                                                  method:'contextMenuEvents',$
                                                  id:'SAVEDATAITEMS'})








    contextBaseFS = WIDGET_BASE(self.atlb, /CONTEXT_MENU,uname='FTW_MENU_S',/col)
;    button1FS = WIDGET_BUTTON(contextBaseFS, VALUE='Untyped',$
;                                        uvalue = {object:self,$
;                                                  method:'contextMenuEvents',$
;                                                  id:'UNTYPED'})
    button2FS = WIDGET_BUTTON(contextBaseFS, VALUE='Resolution',$
                                        uvalue = {object:self,$
                                                  method:'contextMenuEvents',$
                                                  id:'RESOLUTION'})
    button3FS = WIDGET_BUTTON(contextBaseFS, VALUE='Sample',$
                                        uvalue = {object:self,$
                                                  method:'contextMenuEvents',$
                                                  id:'RAWDATA'})
    button4FS = WIDGET_BUTTON(contextBaseFS, VALUE='Background',$
                                        uvalue = {object:self,$
                                                  method:'contextMenuEvents',$
                                                  id:'BACKGROUND'})
    button5FS = WIDGET_BUTTON(contextBaseFS, VALUE='Assign Object to a Set',$
                                        sensitive=0,$
                                        uvalue = {object:self,$
                                                  method:'contextMenuEvents',$
                                                  id:'ASSIGNOBJ'})
    button6FS = WIDGET_BUTTON(contextBaseFS, VALUE='Remove Object',$
                                        uvalue = {object:self,$
                                                  method:'contextMenuEvents',$
                                                  id:'REMOVEOBJ'})
    button6FSa = WIDGET_BUTTON(contextBaseFS, VALUE='Merge Objects',$
                                        sensitive=0,$
                                        uvalue = {object:self,$
                                                  method:'contextMenuEvents',$
                                                  id:'MERGEOBJ'})


    ;ADD I(Q,t) CALCULATION BUTTONS TO THE CONTEXT MENUS
    button7FS = widget_button(contextBaseFS,$
                                sensitive=0,$
                                value='Calculate Q Values',$
                                uname='CALCULATEQS',$
                                uvalue={object:self,$
                                        method:'menuEvents',$
                                        id:'CALCULATEQS',$
                                        parent:'CALCULATIONOPTIONS'})
    button8FS = widget_button(contextBaseFS,$
                                value='Calculate I(Q,t)',$
                                uname='CALCULATEI',$
                                uvalue={object:self,$
                                        method:'menuEvents',$
                                        id:'CALCULATEI',$
                                        parent:'CALCULATIONOPTIONS'})


    contextBaseQ = WIDGET_BASE(self.atlb, /CONTEXT_MENU,uname='QTW_MENU')
    button1Q = WIDGET_BUTTON(contextBaseQ, VALUE='Create New Set',$
                                        sensitive=0,$
                                        uvalue = {object:self,$
                                                  method:'contextMenuEvents',$
                                                  id:'QNEWSET'})
;    button2Q = WIDGET_BUTTON(contextBaseQ, VALUE='Remove This Q',$
;                                        sensitive=0,$
;                                        uvalue = {object:self,$
;                                                  method:'contextMenuEvents',$
;                                                  id:'REMOVEQ'})
;    button3Q = WIDGET_BUTTON(contextBaseQ, VALUE='Keep This Q',$
;                                        sensitive=0,$
;                                        uvalue = {object:self,$
;                                                  method:'contextMenuEvents',$
;                                                  id:'KEEPQ'})

end;defineContextMenus
